<template>
  <client-only>
    <div v-show="display" class="sk-circle">
      <div class="sk-circle1 sk-child"></div>
      <div class="sk-circle2 sk-child"></div>
      <div class="sk-circle3 sk-child"></div>
      <div class="sk-circle4 sk-child"></div>
      <div class="sk-circle5 sk-child"></div>
      <div class="sk-circle6 sk-child"></div>
      <div class="sk-circle7 sk-child"></div>
      <div class="sk-circle8 sk-child"></div>
      <div class="sk-circle9 sk-child"></div>
      <div class="sk-circle10 sk-child"></div>
      <div class="sk-circle11 sk-child"></div>
      <div class="sk-circle12 sk-child"></div>
    </div>
  </client-only>
</template>

<script>
export default {
  name: 'Loader',
  props: {
    display: {
      type: Boolean,
      required: true
    }
  }
}
</script>

<style lang="scss" scoped>
.sk-circle {
  $circleCount: 12;
  $animationDuration: 1.2s;

  margin: 40px auto;
  width: 100px;
  height: 100px;
  position: relative;
  left: 0;
  right: 0;
  z-index: 2;

  .sk-child {
    width: 100%;
    height: 100%;
    position: absolute;
    left: 0;
    top: 0;
  }

  .sk-child:before {
    content: '';
    display: block;
    margin: 0 auto;
    width: 15%;
    height: 15%;
    background-color: #ff641e;
    border-radius: 100%;
    animation: sk-circleBounceDelay $animationDuration infinite ease-in-out both;
  }

  @for $i from 2 through $circleCount {
    .sk-circle#{$i} {
      transform: rotate(360deg / $circleCount * ($i - 1));
    }
  }

  @for $i from 2 through $circleCount {
    .sk-circle#{$i}:before {
      animation-delay: -$animationDuration +
        $animationDuration /
        $circleCount *
        ($i - 1);
    }
  }
}

@keyframes sk-circleBounceDelay {
  0%,
  80%,
  100% {
    transform: scale(0);
  }
  40% {
    transform: scale(1);
  }
}
</style>
